config/routes.rb
Rails.application.routes.draw do
  root "authorities#index"
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    passwords: 'users/passwords'
  }
  
  resources :authorities
  resources :basic_informations
  resources :infrastructures
  resources :events
  resources :departments do
    collection do
      get :get_subjects
    end
  end
end

app/models/affiliated_college.rb
class AffiliatedCollege < ApplicationRecord
	belongs_to :basic_information
	belongs_to :infrastructure
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/authority.rb
class Authority < ApplicationRecord
	belongs_to :designation
	validates :name, :designation_id, presence: true
	mount_uploader :upload_list, FileUploader
end

app/models/basic_information.rb
class BasicInformation < ApplicationRecord
	include PgSearch::Model
 	pg_search_scope :search_by_name, against: :university_name

	validates :university_name, presence: true
	has_one :naac_status
	has_many :affiliated_colleges
	has_many :programmes_offereds
	accepts_nested_attributes_for :naac_status, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :affiliated_colleges, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :programmes_offereds, reject_if: :all_blank, allow_destroy: true

end

app/models/department.rb
class Department < ApplicationRecord
	validates :department_list_id, :program_id, presence: true
	belongs_to :program
	belongs_to :subject, optional: true
	belongs_to :department_list
	has_many :faculties
	has_one :student
	has_one :fee_structure
	accepts_nested_attributes_for :faculties, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :student, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :fee_structure, reject_if: :all_blank, allow_destroy: true

	def fetch_faculties
		if self.faculties.present?
			self.faculties.includes(:faculty_designation).order("faculty_designations.position ASC")
		else
			[]
		end
	end
end

app/models/department_list.rb
class DepartmentList < ApplicationRecord
	has_many :departments
	has_many :faculties, through: :departments
	has_many :students, through: :departments
end

app/models/designation.rb
class Designation < ApplicationRecord
	validates :name, presence: true
	has_many :authorities
end

app/models/event.rb
class Event < ApplicationRecord
	validates :event_file, :department_list_id, presence: true
	belongs_to :department_list
	mount_uploader :event_file, FileUploader
	enum semester: { even: 'even', odd: 'odd' }

end

app/models/faculty.rb
class Faculty < ApplicationRecord
	belongs_to :faculty_designation
	belongs_to :department, optional: true
	mount_uploader :resume, FileUploader
end

app/models/fee_structure.rb
class FeeStructure < ApplicationRecord
	belongs_to :department
end

app/models/hostel.rb
class Hostel < ApplicationRecord
	# validates :hostel_type, presence: true
	enum hostel_type: {"boy's hostel": 0, "girl's hostel": 1}
	belongs_to :infrastructure
end

app/models/ict_infrastructure.rb
class IctInfrastructure < ApplicationRecord
	validates :ict_type, presence: true
	enum ict_type: {"wifi": 0, "broadband": 1}
	enum availability: {"teachers": 0, "students": 1, "both": 2}
	belongs_to :infrastructure
end

app/models/infrastructure.rb
class Infrastructure < ApplicationRecord
	require 'csv'
	validates :campus, presence: true
	has_many :hostels, dependent: :destroy
	has_many :libraries, dependent: :destroy
	has_many :ict_infrastructures, dependent: :destroy

	enum campus: {"main campus": 0, "constituent college": 1, "off campus": 2, "out reach": 3}
	
	accepts_nested_attributes_for :hostels, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :libraries, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :ict_infrastructures, reject_if: :all_blank, allow_destroy: true

	def self.to_csv(infrastructures)
    #headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs", "Hostel Name", "Hostel Type", "Total Boys", "Total Girls", "Library Name", "Total Books", "Total E-books", "Total Journals", "Total E-journals", "ICT Type", "Availability", "No of ICT Enabled Classes", "Speed", "Service Provide", "Bandwidth"]
     headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs"]
    CSV.generate(headers: true) do |csv|
      csv << headers
      if infrastructures.present?
        infrastructures.each do |infra|
        	# hostels_attributes = []
   				# if infra.hostels.present?
   				# 	infra.hostels.each do |h|
   				# 		hostels_attributes << [
   				# 			h.name,
   				# 			h.hostel_type,
   				# 			h.total_boys,
   				# 			h.total_girls
   				# 		].flatten
   				# 	end
   				# end

   				# libraries_attributes = []
   				# if infra.libraries.present?
   				# 	infra.libraries.each do |l|
   				# 		hostels_attributes << [
   				# 			l.name,
   				# 			l.total_books,
   				# 			l.total_ebooks,
   				# 			l.total_journals,
   				# 			l.total_ejournals,
   				# 		].flatten
   				# 	end
   				# end

   				# ict_attributes = []
   				# if infra.ict_infrastructures.present?
   				# 	infra.ict_infrastructures.each do |i|
   				# 		hostels_attributes << [
   				# 			i.ict_type,
   				# 			i.availability,
   				# 			i.no_of_ict_enabled_classes,
   				# 			i.speed,
   				# 			i.service_provider,
   				# 			i.bandwidth
   				# 		].flatten
   				# 	end
   				# end

          csv << [
            infra.name,
            infra.campus,
            infra.land_availability,
            infra.no_of_classes,
            infra.no_of_labs
          ].flatten
        end

      end
    end
  end 

end

app/models/library.rb
class Library < ApplicationRecord
	belongs_to :infrastructure
end

app/models/naac_status.rb
class NaacStatus < ApplicationRecord
	validates :grade, presence: true
	belongs_to :basic_information
end

app/models/program.rb
class Program < ApplicationRecord
	validates :name, presence: true
	has_many :subjects
end

app/models/sanctioned_intake.rb
class SanctionedIntake < ApplicationRecord
	belongs_to :student
	enum intake_type: {"government": 0, "management": 1}
end

app/models/student.rb
class Student < ApplicationRecord
	belongs_to :department
end

app/models/subject.rb
class Subject < ApplicationRecord
	validates :name, presence: true
	belongs_to :program
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/authorities_controller.rb
class AuthoritiesController < ApplicationController
  before_action :set_authority, only: %i[ show edit update destroy ]

  def index
    @authorities = Authority.includes(:designation).order('designations.position ASC')
  end

  def show
  end

  def new
    @authority = Authority.new
  end

  def edit
  end

  def create
    @authority = Authority.new(authority_params)
    respond_to do |format|
      if @authority.save
        format.html { redirect_to authorities_url, notice: "Authority was successfully created." }
        format.json { render :show, status: :created, location: @authority }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @authority.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @authority.update(authority_params)
        format.html { redirect_to authorities_url, notice: "Authority was successfully updated." }
        format.json { render :show, status: :ok, location: @authority }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @authority.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @authority.destroy
    respond_to do |format|
      format.html { redirect_to authorities_url, notice: "Authority was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    def set_authority
      @authority = Authority.find_by(id: params[:id])
    end

    def authority_params
      params.require(:authority).permit(:name, :qualification, :date_of_appointment, :email, :contact_number, :designation_id, :upload_list)
    end
end

app/helpers/authorities_helper.rb
module AuthoritiesHelper
end

app/helpers/events_helper.rb
module EventsHelper

	def semester_collection
		[
			["Even", "even"],
			["Odd", "odd"]
		]
	end
end

app/views/authorities/_form.html.erb
<div class="shadow-box">
  <%= simple_form_for @authority, html: { class: "row mt-4"} do |f| %>
    <%= f.error_notification %>
    <div class="col-md-3">
      <%= f.input :name, label: "NAME", input_html: { class: "form-control form-flied" } %>
    </div>
    <div class="col-md-3">
      <%= f.input :designation_id, label: "DESIGNATION", collection: designation_collection, input_html: {class: "form-control form-flied"} %>
    </div>
    <div class="col-md-3 bog-div">
      <%= f.input :email, label: "EMAIL", input_html: {class: "form-control form-flied"} %>
    </div>
    <div class="col-md-3 bog-div">
      <%= f.input :contact_number, label: "CONTACT NUMBER", input_html: {class: "form-control form-flied"} %>
    </div>
    <div class="col-md-3 chancellor-div">
      <div class="chancellor-div">
        <%= f.input :qualification, label: "QUALIFICATION", input_html: {class: "form-control form-flied"} %>
      </div>
    </div>
    <div class="col-md-3 chancellor-div">
      <%= f.input :date_of_appointment, label: "DATE OF APPOINTMENT", input_html: {class: "form-control form-flied datepicker"} %>
    </div>
    <div class="col-md-3 upload-div">
      <%= f.input :upload_list, label: "UPLOAD LIST", as: :file, input_html: { class: "form-control form-flied mgrn-left-10" } %>
    </div>
    <div class="form-actions">
      <%= f.button :submit, "SAVE",class: "btn btn-primary btn-blue" %>
    </div>
  <% end %>
</div>

<script type="text/javascript">
  $(document).ready(function(){
    $('.datepicker').datepicker({
      autoclose: true
    });
    
    var designation = $(this).find('option:selected').text();
    if (designation == "Chancellor") {
      $('.bog-div').show();
      $('.chancellor-div').hide();
      $('.upload-div').hide();
    }else if ((designation == "BoG’s") || (designation == "Academic Council Member")) {
      $('.bog-div').hide();
      $('.chancellor-div').hide();
      $('.upload-div').show();
    }else{
      $('.bog-div').show();
      $('.chancellor-div').show();
      $('.upload-div').hide();
    }
  });

  $('#authority_designation_id').on('change', function(){
    var designation = $(this).find('option:selected').text();
    if (designation == "Chancellor") {
      $('.bog-div').show();
      $('.chancellor-div').hide();
      $('.upload-div').hide();
    }else if ((designation == "BoG’s") || (designation == "Academic Council Member")) {
      $('.bog-div').hide();
      $('.chancellor-div').hide();
      $('.upload-div').show();
    }else{
      $('.bog-div').show();
      $('.chancellor-div').show();
      $('.upload-div').hide();
    }
  });
</script>

app/views/authorities/edit.html.erb
<div class="mt-5">
	<%= link_to image_tag("back.svg", class: "pr-2 me-2")+"Leadership >", authorities_path, class: "page-head" %>
	<%= link_to "Edit Leadership", "javascript:void(0)", class: "page-head-in" %>
</div>
<%= render "form", authority: @authority %>

app/views/authorities/index.html.erb
<div class="d-flex justify-content-between mt-5">
  <div class="sub-head">Leadership</div>
  <%= link_to "Add", new_authority_path, class: "btn btn-primary btn-blue" %>
</div>

<div class="table-responsive mt-5">
  <table class="table table-striped table-borderless table-custom">
    <thead class="table-purple">
      <tr>
        <th scope="col">Name</th>
        <th scope="col">Designation</th>
        <th scope="col">Uploaded List</th>
        <th scope="col">Email</th>
        <th scope="col">Contact Number</th>
        <th scope="col">Qualification</th>
        <th scope="col">Date of Appointment</th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody>
      <% @authorities.each do |authority| %>
        <tr>
          <td><%= authority.name %></td>
          <td><%= authority.designation.try(:name) %></td>
          <td>
            <% if authority.upload_list.file.present? %>
              <%= link_to "List", authority.upload_list.url, class: "list-link", target: :_blank %>
            <% end %>
          </td>
          <td><%= authority.email %></td>
          <td><%= authority.contact_number %></td>
          <td><%= authority.qualification %></td>
          <td><%= authority.date_of_appointment %></td>
          <td>
            <%= link_to image_tag("edit.svg", class: "btn btn-bg btn-edit"), edit_authority_path(authority) %>
            <%= link_to image_tag("delete.svg", class: "btn btn-bg"), authority_path(authority), data: { turbo_method: :delete, confirm: 'Are you sure?' } %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/authorities/new.html.erb
<div class="mt-5">
	<%= link_to image_tag("back.svg", class: "pr-2 me-2")+"Leadership >", authorities_path, class: "page-head" %>
	<%= link_to "New Leadership", "javascript:void(0)", class: "page-head-in" %>
</div>
<%= render "form", authority: @authority %>